<template>
  <div class="dashboard-loans-page pt-3 pb-5">
    <h1 class="page-title">Loans</h1>
    <div class="mt-3">
      <div class="d-flex justify-content-end">
        <vs-button href="/user/dashboard/loans/new-loan" class="px-2" primary>
          <span class="me-2"> +</span>New Loan
        </vs-button>
      </div>

      <div class="row mt-3" v-if="!loanHistory.length">
        <div class="col-sm-12 col-md-4">
          <h4 class="fw-bold">Total Live Balance</h4>
          <div class="mt-4">
            <h2 class="fw-bold">
              <sup class="h6">₦</sup>
              0.
              <sub> 00 </sub>
            </h2>
          </div>
          <div class="mt-5">
            <p class="fw-bold">Loan Details</p>
            <div class="loans-details-card p-4">
              <p class="fst-italic text-center">
                You currently have no loans running. <br />
                Click the button above to apply for one
              </p>
            </div>
          </div>
        </div>
        <div class="col-sm-12 col-md-8">
          <p class="fw-bold">Loan History</p>
          <div class="loans-details-card p-4">
            <p class="fst-italic text-center">
              You currently have no loan running. <br />
              Click the button above to apply for one
            </p>
          </div>
        </div>
        <div class="col-sm-12 col-md-6"></div>
      </div>

      <div v-else class="row mt-3">
        <div class="col-sm-12 col-md-4">
          <h4 class="fw-bold">Total Live Balance</h4>
          <div class="mt-4">
            <h2 class="fw-bold">
              {{ activeBalance | formatPrice }}
            </h2>
          </div>
          <div class="mt-5">
            <p class="fw-bold">Loan Details</p>
            <div class="loans-details-card p-4">
              <div class="row align-items-center">
                <div class="col-sm-12 col-md-6">
                  <div class="pie-chart-container position-relative">
                    <div class="chart-data">
                      <div class="text-center">
                        <p class="m-0">Paid</p>
                        <p class="m-0">
                          {{
                            calculateLoanDifference(
                              currentLoan.principalAmount,
                              currentLoan.totalPaid
                            )
                          }}%
                        </p>
                        <p class="fw-bold">
                          {{ currentLoan.totalPaid | formatPrice }}
                        </p>
                      </div>
                    </div>
                    <div class="pie-chart">
                      <svg viewBox="0 0 36 36" class="circular-chart orange">
                        <path
                          class="circle-bg"
                          d="M18 2.0845
          a 15.9155 15.9155 0 0 1 0 31.831
          a 15.9155 15.9155 0 0 1 0 -31.831"
                        />
                        <path
                          class="circle"
                          :stroke-dasharray="`${calculateLoanDifference(
                            currentLoan.principalAmount,
                            currentLoan.totalPaid
                          )}, 100`"
                          d="M18 2.0845
          a 15.9155 15.9155 0 0 1 0 31.831
          a 15.9155 15.9155 0 0 1 0 -31.831"
                        />
                      </svg>
                    </div>
                  </div>
                </div>
                <div class="col-sm-12 col-md-6 text-end">
                  <div>
                    <p>Outstanding Balance</p>
                    <h3 class="fw-bold">
                      {{ currentLoan.balance | formatPrice }}
                    </h3>
                  </div>
                  <div>
                    <p>Interest Rate</p>
                    <h3 class="fw-bold">
                      {{ currentLoan.interestRate }}
                      %
                    </h3>
                  </div>
                  <div>
                    <p>Next Payment</p>
                    <h3 class="fw-bold">
                      {{ currentLoan.nextPaymentAmount | formatPrice }}
                    </h3>
                    <p>
                      {{ currentLoan.nextPaymentDate | formatDate }}
                    </p>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-sm-12 col-md-8">
          <p class="fw-bold">Loan History</p>
          <div class="loans-details-card p-4">
            <table class="table table-borderless">
              <thead>
                <tr>
                  <th scope="col" v-for="(table, i) in tableHead" :key="i">
                    {{ table }}
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(loan, i) in loanHistory" :key="i">
                  <td>Monthly Payment</td>
                  <td>
                    {{ loan.loanPlan.name }}
                  </td>
                  <td>
                    <p class="text-danger fw-bold">
                      {{ loan.balance | formatPrice }}
                    </p>
                  </td>
                  <td>
                    {{ loan.dueDate | formatDate }}
                  </td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
        <div class="col-sm-12 col-md-6"></div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  layout: 'dashboard',
  components: {},
  data: () => ({
    tableHead: ['Description', 'Source', 'Amount', 'Date'],
    currentLoan: {},
    activeBalance: [],
    loanHistory: [],
  }),
  // async asyncData({ $axios }) {
  //   const activeBalance = await $axios.$get('loan/user/balance')
  //   const loanHistory = await $axios.$get('/loan/user/history?page=1&limit=10')
  //   console.log(activeBalance)
  //   return {
  //     activeBalance: activeBalance.payload || 0,
  //     loanHistory: loanHistory.payload.data || [],
  //   }
  // },
  created() {
    this.fetchData()
  },
  methods: {
    async fetchData() {
      try {
        const activeBalance = await this.$axios.$get('loan/user/balance')
        const loanHistory = await this.$axios.$get(
          '/loan/user/history?page=1&limit=10'
        )

        this.activeBalance = activeBalance.payload || 0
        this.loanHistory = loanHistory.payload.data || []
        this.currentLoan = this.loanHistory.length ? this.loanHistory[0] : {}
      } catch (error) {
        console.log(error)
      }
    },
    calculateLoanDifference(actualAmount, amount) {
      if (!actualAmount || !amount) return 0
      return Math.round(100 - ((actualAmount - amount) / actualAmount) * 100)
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-loans-page {
  .loans-details-card {
    background: #ffffff;
    border-radius: 20px;
    min-height: 300px;
    // display: flex;
    // align-items: center;
    // justify-content: center;
  }
  .pie-chart-container {
    width: 200px;
    max-height: 200px;
    display: flex;
    align-items: center;
    justify-content: center;
    .chart-data {
      position: absolute;
    }
  }
  .pie-chart {
    width: 200px;
    justify-content: space-around;

    .circular-chart {
      display: block;
      margin: auto auto;
      max-width: 100%;
      max-height: 200px;
    }

    .circle-bg {
      fill: none;
      stroke: #eee;
      stroke-width: 2.2;
    }

    .circle {
      fill: none;
      stroke-width: 2.2;
      stroke-linecap: round;
      animation: progress 1s ease-out forwards;
    }

    @keyframes progress {
      0% {
        stroke-dasharray: 0 100;
      }
    }

    .circular-chart.orange .circle {
      stroke: $primary;
    }
    .percentage {
      fill: #666;
      font-family: sans-serif;
      font-size: 0.5em;
      text-anchor: middle;
    }
  }
}
</style>
